/***************************************************************************
 *            init_client.c
 *
 *  Fri Oct 24 11:26:38 2003
 *  Copyright  2003  Phil Kett
 *  pkett@genesis-midi.com
 ****************************************************************************/

#include "../include/remsync.h"
#include <netdb.h>
#include <sys/socket.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int
init_client (int port, char *servername)
{
	int client_sd;
	struct sockaddr_in dest;	//struct for destination address
	struct hostent *hostname;	//struct for destination hostname
	struct in_addr address;	// struct for destination IP address
	char *ip_addr[20], message[BIG_BUF];

	bzero (&dest, sizeof (dest));
	if ((hostname = gethostbyname (servername)) == NULL)
	{
		printf("Unable to get host %s\n", servername);
		exit (1);
	}
	address.s_addr = *(long *) hostname->h_addr_list[0];	//copy hostname result from gethostbyname into IP address struct
	*ip_addr = inet_ntoa (address);	//convert IP address to string
	if (conf.debug) printf ("IP Addr: %s\n", *ip_addr);
	dest.sin_family = AF_INET;	//set destination address family
	inet_aton (*ip_addr, &dest.sin_addr);	// convert IP address string into format for destination struct
	dest.sin_port = htons (port);	//convert port
	client_sd = socket (AF_INET, SOCK_STREAM, 0);	//create socket client_sd
	if (client_sd == -1)
	{
		perror("Socket call failed\n");
		exit (1);
	}
	if (connect (client_sd, (struct sockaddr *) &dest, sizeof (dest)) ==	//create connection
	    -1)
	{
		perror("Connect failed\n");
		exit (1);
	}
	read(client_sd, message, BIG_BUF);
	strip_string(message);
	if (strstr(message, "Remosync") != NULL) {
		if (strcmp(message, VERSTR) != 0) {
			perror("Not the same version of Remosync\nExiting...\n");
			exit(-1);
		}
	} else {
		printf("%s\n", message);
		exit(-1);
	}
	return client_sd;	//return file descriptor of connection
}
